@ECHO OFF
REM Do_Run_ALL.cmd, 23-APR-13, ABr
REM Run all mgmt scripts on a system reboot.
REM Can be run from GPO (domain) or from PsExec / WMI (non-domain)

REM Set this to point to the anonymous read share for scripts
REM SET Do_Run_All_NetPath=\\3rdparty-updates.armycloud.cloud.army.mil\AnonRead\MgmtScripts
SET Do_Run_All_NetPath=\\172.24.0.33\AnonRead\MgmtScripts

REM Get hostname
FOR /F "usebackq" %%i IN (`hostname`) DO SET Do_Run_All_HOSTNAME=%%i

REM Create output folder
SET Do_Run_All_OUTPUT_DIR=%Do_Run_All_NetPath%\..\MgmtScriptsOut\%Do_Run_All_HOSTNAME%
IF EXIST %Do_Run_All_OUTPUT_DIR% GOTO hasDir
MKDIR %Do_Run_All_OUTPUT_DIR%
:hasDir

REM Set output files
For /f "tokens=2-4 delims=/ " %%a in ('date /t') do (set mydate=%%c%%a%%b)
For /f "tokens=1-2 delims=/: " %%a in ('time /t') do (set mytime=%%a%%b)
REM Stupid Windoze doesn't return seconds, so get a random value
SET Do_Run_All_RANDOM=%RANDOM%
REM ECHO ON
SET Do_Run_All_OUTPUT_FILE=%Do_Run_All_OUTPUT_DIR%\%mydate%-%mytime%-%Do_Run_All_RANDOM%.log
SET Do_Run_All_ERROR_FILE=%Do_Run_All_OUTPUT_DIR%\%mydate%-%mytime%-%Do_Run_All_RANDOM%.err


REM Setup output file
SET Do_Run_All_DEVROOT=%~dp0
ECHO Running '%Do_Run_All_DEVROOT%' at %mydate%-%mytime% > %Do_Run_All_OUTPUT_FILE%
FOR /F "usebackq delims=" %%i IN (`whoami`) DO SET Do_Run_All_WHOAMI=%%i
ECHO Running as %Do_Run_All_WHOAMI% >> %Do_Run_All_OUTPUT_FILE%

REM Delete log files older than 7 days
REM ECHO ON
cscript //NoLogo %Do_Run_All_NetPath%\impl_delete_older_files.vbs %Do_Run_All_OUTPUT_DIR% 7 >> %Do_Run_All_OUTPUT_FILE%

REM Run the Run_ALL command with output redirected based on the above
%Do_Run_All_NetPath%\Run_ALL.cmd %Do_Run_All_NetPath% >> %Do_Run_All_OUTPUT_FILE% 2> %Do_Run_All_ERROR_FILE%

