@ECHO OFF
REM impl_Check_Firefox.cmd, 26-APR-13, ABr
REM Runs the impl_check_firefox.vbs script

REM Get current folder and managed script
SET DEVROOT=%~dp0
REM ECHO "DEVROOT=%DEVROOT%"
SET COMMON=%DEVROOT%impl_common.vbs
IF NOT EXIST %COMMON% GOTO NoCommon
SET SCRIPT=%DEVROOT%impl_check_firefox.vbs
IF NOT EXIST %SCRIPT% GOTO NoScript

REM Get pointer to target and validate
SET TARGET=%DEVROOT%..\Firefox
REM ECHO "TARGET=%TARGET%"
IF NOT EXIST "%TARGET%\winver.txt" GOTO NoTarget

REM Format output
For /f "tokens=2-4 delims=/ " %%a in ('date /t') do (set mydate=%%c-%%a-%%b)
For /f "tokens=1-2 delims=/:" %%a in ("%TIME%") do (set mytime=%%a%%b)
SET OUTPUT_FILE=%TEMP%\impl_check_firefox-%mydate%-%mytime%.log
REM ECHO "OUTPUT_FILE=%OUTPUT_FILE%"

REM Create WSF file for include support
SET WSF_WRAP=%TEMP%\wsf_wrap.wsf
ECHO ^<job id="impl_check_Firefox"^> > %WSF_WRAP%
ECHO   ^<script language="vbscript" src="%COMMON%"/^> >> %WSF_WRAP%
ECHO   ^<script language="vbscript" src="%SCRIPT%"/^> >> %WSF_WRAP%
ECHO ^</job^> >> %WSF_WRAP%

REM Run script and check output
cscript //NoLogo "%WSF_WRAP%" "%TARGET%" > "%OUTPUT_FILE%"
TYPE "%OUTPUT_FILE%"
SET prg_err=
For /f "delims=1" %%a in ('findstr "ERROR:" "%OUTPUT_FILE%"') do (set prg_err=%%a)
IF $%prg_err%==$ GOTO okrun
DEL "%OUTPUT_FILE%"
GOTO done

:okrun
DEL "%OUTPUT_FILE%"
ECHO ***OK***
GOTO done

:NoCommon
ECHO ERROR: Unable to locate required file impl_common.vbs; check directory structure
GOTO done

:NoScript
ECHO ERROR: Unable to locate required script; check directory structure
GOTO done

:NoTarget
ECHO ERROR: Unable to locate required target directory; check directory structure
GOTO done

:done
ECHO Batch file completed.

