' impl_common.vbs, ABr, 24-APR-13
' Common vbscript functions

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Globals
g_sNotFound = "***NOPE***"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Functions common to all modules

' is string NULL or Zero or Empty?
Function isBlank(Value)
  'returns True if Empty or NULL or Zero
  If IsEmpty(Value) or IsNull(Value) Then
    isBlank = True
    Exit Function
  ElseIf VarType(Value) = vbString Then
    If Value = "" Then
      isBlank = True
      Exit Function
    End If
  ElseIf IsObject(Value) Then
    If Value Is Nothing Then
      isBlank = True
      Exit Function
    End If
  ElseIf IsNumeric(Value) Then
    If Value = 0 Then
      isBlank = True
      Exit Function
    End If
  Else
    isBlank = False
  End If
End Function

' detect OS type (32-bit or 64-bit)
Function isOs32()
  Dim sAddressWidth
  sAddressWidth = GetObject("winmgmts:root\cimv2:Win32_Processor='cpu0'").AddressWidth
  If sAddressWidth = "64" Then
    isOs32 = False
  Else
    isOs32 = True
  End If
End Function

' write program output
Function writeOutput(sMsg)
  Dim d, s

  ' format date
  d = Now()
  s = Year(d) & "-" & Right("00" & Month(d), 2) & "-" & Right("00" & Day(d), 2) _
    & " " & Right("00" & Hour(d), 2) & ":" & Right("00" & Minute(d), 2) & ":" & Right("00" & Second(d), 2)

  WScript.Echo s & " " & sMsg
End Function

' read from Windows Registry
Function readFromRegistry (strRegistryKey, strDefault )
  Dim WSHShell, value

  On Error Resume Next
  Set WSHShell = CreateObject("WScript.Shell")
  value = WSHShell.RegRead( strRegistryKey )
  If err.number <> 0 Then
    readFromRegistry= strDefault
  Else
    readFromRegistry=value
  End If
  Err.Clear
  On Error Goto 0
  Set WSHShell = Nothing
End Function

' read key=value text file and return value for passed key
Function extractRefKey(keyFile, sKey, sDefault)
  Const ForReading = 1

  Set objFSO = CreateObject("Scripting.FileSystemObject")
  Set objFile = objFSO.OpenTextFile(keyFile, ForReading)
  'writeOutput("Reading keyfile '" & keyFile & "' for key '" & sKey & "'")
  sResult = sDefault
  sKeySearch = sKey & "="
  Do Until objFile.AtEndOfStream
    strLine = objFile.ReadLine
    idx = InStr(strLine, sKeySearch)
    If idx > 0 Then sResult = Mid(strLine, idx + Len(sKeySearch))
  Loop
  objFile.Close
  set objFSO = Nothing
  extractRefKey = sResult
End Function

' create a folder
Function doCreateFolder(sFolder)
  Set oFSO = CreateObject("Scripting.FileSystemObject")
  On Error Resume Next
  oFSO.CreateFolder sFolder
  Err.Clear
  On Error Goto 0
  Set oFSO = Nothing
End Function

' delete a folder
Function doDeleteFolderContents(sDest)
  Const DeleteReadOnly = TRUE
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  On Error Resume Next
  objFSO.DeleteFile(sDest & "\*"), DeleteReadOnly
  Err.Clear
  On Error Resume Next
  objFSO.DeleteFolder(sDest & "\*"),DeleteReadOnly
  Err.Clear
  On Error Goto 0
  Set objFSO = Nothing
End Function

' copy a file
Function doCopyFile(sSrc, sDestFolder, sDestFile)
  Set fso = CreateObject("Scripting.FileSystemObject")
  'Check to see if the file already exists in the destination folder
  sDestPath = sDestFolder & "\" & sDestFile
  If fso.FileExists(sDestPath) Then
    fso.DeleteFile sDestPath
  End If
  fso.CopyFile sSrc, sDestPath, True
  Set fso = Nothing
End Function

' copy a folder
Function doCopyFolder(sSrc, sDest)
  ' ABr: went round-n-round here, m$ docs suck
  sSrcPath = sSrc
  sDestPath = sDest
  Set FSO =CreateObject("scripting.FileSystemObject")
  FSO.CopyFolder sSrcPath, sDestPath, True
  Set FSO = Nothing
End Function

' read MSI file from a folder (only expect one)
Function getMSI(sDir)
  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set FLD = FSO.GetFolder(sDir)
  writeOutput("getMSI: Looking at '" & sDir & "'")
  sName = ""
  For Each fil In FLD.Files
    sExt = FSO.GetExtensionName(fil.Name)
    writeOutput("getMSI: Ext='" & sExt & "'")
    If UCase(sExt) = "MSI" Then
      sName = sDir & "\" & fil.Name
      Exit For
    End If
  Next
  Set FLD = Nothing
  Set FSO = Nothing
  getMSI = sName
End Function

' get env variable
Function ReadEnv(sKey)
  Set wshShell = CreateObject( "WScript.Shell" )
  sKeyName = "%" & sKey & "%"
  ReadEnv = wshShell.ExpandEnvironmentStrings(sKeyName)
  Set wshShell = Nothing
End Function

' exit the program
Function doExit(sExitMsg)
  If Not isBlank(sExitMsg) Then
    writeOutput(sExitMsg)
  End If
  writeOutput("check_common.vbs: END")
  WScript.Quit
End Function

